# frozen_string_literal: true

module Checkson
  module Check
    class Base
      attr_reader :status, :messages

      def initialize(_opts = {})
        @messages = []
        @status = :ok
      end

      def ok?
        @status == :ok
      end

      def failed?
        !ok?
      end

      protected

      def log(message)
        @messages << message
      end

      def ok!
        @status = :ok
      end

      def failed!
        @status = :failed
      end
    end
  end
end
