# frozen_string_literal: true

module Checkson
  module Check
    module Pkganager
      class AbstractPkgmanager
        def self.descendants
          ObjectSpace.each_object(Class).select { |klass| klass < self }
        end
      end

      class Pkgmanager < AbstractPkgmanager
        def self.adapters
          AbstractPkgmanager.descendants - [self]
        end

        def self.adapter
          @adapter ||= adapters.find { |adapter| adapter.supports_os? Facter['osfamily'].value.downcase }
        end
      end
    end
  end
end
