# frozen_string_literal: true

module Checkson
  module Check
    class Shell < Checkson::Check::Base
      def initialize(opts = {})
        @opts = (@opts || {}).merge(opts)
        super()
      end

      def check
        raise ArgumentError, 'No code given' unless @opts[:code]

        execute(@opts[:code])
        failed! unless $?.exitstatus.zero?
      end

      protected

      def execute(command)
        `sh -c "#{command.gsub(/"/, '\"')}"`
      end
    end
  end
end
