# frozen_string_literal: true

require 'ostruct'

module Checkson
  class Config
    attr_reader :checks, :name

    include Checkson::Check

    def initialize(file)
      @checks = []
      instance_eval(File.read(file))
    end

    protected

    def check(description, &block)
      context = Checkson::Context.new(&block)
      @checks << OpenStruct.new(
        klass: context.klass,
        description: description,
        params: context.params,
        help: context.help
      )
    end
  end
end
