# frozen_string_literal: true

module Checkson
  class Context
    attr_reader :klass, :params

    def initialize(&block)
      @klass = nil
      @params = {}
      @help = []
      instance_eval(&block)
    end

    def using(klass)
      @klass = klass
    end

    def set(key, value)
      @params[key.to_sym] = value
    end

    def help(message = nil)
      @help << message if message
      @help
    end
  end
end
